/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controller;

import domen.Komponenta;
import domen.Memorija;
import domen.Monitor;
import domen.Procesor;
import domen.Usluga;
import domen.UslugaAdapter;
import domen.UslugaCiscenjeVirusa;
import domen.UslugaIstalacijaOS;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author student1
 */
public class Controller {

    static Controller instance;
    List<Komponenta> listaKomponenata;
    List<Usluga> listaUsluga;

    private Controller() {
        listaKomponenata = new ArrayList<>();
        Komponenta procesor = new Procesor(3.5, "Intel", new BigDecimal(5000), "Winwin");
        Komponenta procesor2 = new Procesor(2.9, "AMD", new BigDecimal(3000), "Emmi");
        Komponenta monitor = new Monitor("Benq", new BigDecimal(5000), "Winwin", 19);
        Komponenta memorija = new Memorija(4, "Kingston DDR3", new BigDecimal(2400), "Emmi");
        listaKomponenata.add(memorija);
        listaKomponenata.add(monitor);
        listaKomponenata.add(procesor);
        listaKomponenata.add(procesor2);

        listaUsluga = new ArrayList<>();
        Usluga u1 = new UslugaIstalacijaOS("Windows 10", "PRO", new BigDecimal(500), new BigDecimal(2000), "Pera");
        Usluga u2 = new UslugaIstalacijaOS("Windows 7", "Ultimate", new BigDecimal(250), new BigDecimal(1500), "Zika");
        Usluga u3 = new UslugaCiscenjeVirusa("Kaspersky", " ", new BigDecimal(200), new BigDecimal(1000), "Laza");
        listaUsluga.add(u1);
        listaUsluga.add(u2);
        listaUsluga.add(u3);

    }

    public static Controller getInstance() {
        if (instance == null) {
            instance = new Controller();
        }
        return instance;
    }

    public List<Komponenta> dajSveKomponente() {
        return listaKomponenata;
    }

    public List<Komponenta> dajSVE() {
        List<Komponenta> lista = new ArrayList<>(listaKomponenata);
        for (Usluga usluga : listaUsluga) {
            lista.add(new UslugaAdapter(usluga));
        }
        return lista;
    }

}
